/*
q3unban plugin for sudppipe
by Luigi Auriemma
e-mail: aluigi@autistici.org
web:    aluigi.org
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "q3huff.h"

#ifdef WIN32
    #include <windows.h>

    BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved) {
        return(TRUE);
    }
    BOOL WINAPI _DllMain(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved) {
        return(TRUE);
    }
#else
    // gcc -shared -fPIC -o FILE.SO FILE.C
#endif

typedef uint8_t     u8;
typedef uint16_t    u16;
typedef uint32_t    u32;



#define VER                 "q3unban plugin for sudppipe 0.1.2"
#define MAX_INFO_STRING     1024



int sudp_init(u8 *data) {
    printf("- PLUGIN: %s\n", VER);

    if(data && !data[0]) {
        printf("- no plugin's options\n");
        return(1);
    }
    return(0);
}



int sudp_pck(u8 *data, int datalen) {
    int     diff,
            compress  = 1,
            connectsz = 12;
    u8      *connect,
            *p;

    if(datalen < 12) return(datalen);
    if(memcmp(data, "\xff\xff\xff\xff", 4)) return(datalen);
    if(memcmp(data + 4, "connect ", 8)) {
        if(memcmp(data + 4, "\x02" "connect ", 9)) return(datalen);
        connectsz = 13;
    }
    connect = data + connectsz;
    if(connect[0] == '\"') compress = 0;

    if(compress) datalen = Huff_DecompressPacket(data, connectsz, datalen, 0xffff);

    if(connect[0] == '\"') connect++;
    p = memchr(connect, '\"', datalen - (connect - data));
    if(!p) p = data + datalen;
    if((p - connect) < MAX_INFO_STRING) {
        memmove(connect + MAX_INFO_STRING, p, datalen - (p - data));
        diff = MAX_INFO_STRING - (p - connect);
        memset(p, 'A', diff);
        p[0]        = '\\';
        p[diff / 2] = '\\';
        datalen += diff;
        printf("- q3unban activated\n");
    }

    if(compress) datalen = Huff_CompressPacket(data, connectsz, datalen);
    return(datalen);
}



int sudp_vis(u8 *data, int len) {
    return(len);
}


